- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# bigip_ssl_key – Import/Delete SSL keys from BIG-IP

New in version 2.5.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- This module will import/delete SSL keys on a BIG-IP. Keys can be imported from key files on the local disk, in PEM format.

## Requirements

The below requirements are needed on the host that executes this module.

- BIG-IP >= v12

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
content string |  | Sets the contents of a key directly to the specified value. This is used with lookup plugins or for anything with formatting or templating. This must be provided when `state` is `present`. aliases: key_content
name string / required |  | The name of the key.
partition string added in 2.5 | Default: "Common" | Device partition to manage resources on.
passphrase string |  | Passphrase on key.
provider dictionary added in 2.5 |  | A dict object containing connection details.
| auth_provider string |  | Configures the auth provider for to obtain authentication tokens from the remote device. This option is really used when working with BIG-IQ devices.
| password string / required |  | The password for the user account used to connect to the BIG-IP. You may omit this option by setting the environment variable `F5_PASSWORD`. aliases: pass, pwd
| server string / required |  | The BIG-IP host. You may omit this option by setting the environment variable `F5_SERVER`.
| server_port integer | Default: 443 | The BIG-IP server port. You may omit this option by setting the environment variable `F5_SERVER_PORT`.
| ssh_keyfile path |  | Specifies the SSH keyfile to use to authenticate the connection to the remote device. This argument is only used for cli transports. You may omit this option by setting the environment variable `ANSIBLE_NET_SSH_KEYFILE`.
| timeout integer |  | Specifies the timeout in seconds for communicating with the network device for either connecting or sending commands. If the timeout is exceeded before the operation is completed, the module will error.
| transport string | Choices: cli rest ← | Configures the transport connection to use when connecting to the remote device.
| user string / required |  | The username to connect to the BIG-IP with. This user must have administrative privileges on the device. You may omit this option by setting the environment variable `F5_USER`.
| validate_certs boolean | Choices: no yes ← | If `no`, SSL certificates are not validated. Use this only on personally controlled sites using self-signed certificates. You may omit this option by setting the environment variable `F5_VALIDATE_CERTS`.
state string | Choices: present ← absent | When `present`, ensures that the key is uploaded to the device. When `absent`, ensures that the key is removed from the device. If the key is currently in use, the module will not be able to remove the key.

## Notes

Note

- This module does not behave like other modules that you might include in roles where referencing files or templates first looks in the role’s files or templates directory. To have it behave that way, use the Ansible file or template lookup (see Examples). The lookups behave as expected in a role context.
- For more information on using Ansible to manage F5 Networks devices see https://www.ansible.com/integrations/networks/f5.
- Requires BIG-IP software version >= 12.
- The F5 modules only manipulate the running configuration of the F5 product. To ensure that BIG-IP specific configuration persists to disk, be sure to include at least one task that uses the bigip_config module to save the running configuration. Refer to the module’s documentation for the correct usage of the module to save your running configuration.

## Examples

    - name: Use a file lookup to import key
      bigip_ssl_key:
        name: key-name
        state: present
        content: "{{ lookup('file', '/path/to/key.key') }}"
        provider:
          server: lb.mydomain.com
          user: admin
          password: secret
      delegate_to: localhost

    - name: Delete key
      bigip_ssl_key:
        name: key-name
        state: absent
        provider:
          server: lb.mydomain.com
          user: admin
          password: secret
      delegate_to: localhost

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
key_checksum string | changed and created | SHA1 checksum of the key that was provided. Sample: cf23df2207d99a74fbe169e3eba035e633b65d94
key_filename string | created | The name of the SSL certificate key. The `key_filename` and `cert_filename` will be similar to each other, however the `key_filename` will have a `.key` extension. Sample: cert1.key
key_source_path string | created | Path on BIG-IP where the source of the key is stored Sample: /var/config/rest/downloads/cert1.key

## Status

- This module is guaranteed to have backward compatible interface changes going forward. [stableinterface]
- This module is maintained by an Ansible Partner. [certified]

### Authors

- Tim Rupp (@caphrim007)
- Wojciech Wypior (@wojtek0806)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.